'
' -----------------------------------------------------------------------------
' QWindow Tools         Component Code                May 3rd, 2007     Jacques
'          Get:   Handle, ClassName, WindowText, Childs, Parent
' -----------------------------------------------------------------------------
'
Declare Function GCH_FindWindowEx Lib "user32" Alias "FindWindowExA" (ByVal hWnd1 As Long, _
                           ByVal hWnd2 As Long, ByVal lpsz1 As Long, ByVal lpsz2 As Long) As Long
Declare Function GCH_GetClassName Lib "user32" Alias "GetClassNameA" (ByVal hwnd As Long, _
                                      ByVal lpClassName As Long, ByVal nMaxCount As Long) As Long
Declare Function GCH_GetWindowText Lib "user32" Alias "GetWindowTextA" (ByVal hwnd As Long, _
                                               ByVal lpString As Long, ByVal cch As Long) As Long
' -------------------------------------
'
Type QWindowTools Extends QObject
  With QWindowTools
' ---- Property -----------------------
Public:
    Wnd        As String
    Separator  As String
    Result     As String      ' format: Count 0 handle,parent_1_handle, ..2.., ... 0 ClassName0windowText
    lstResult  As QStringList
    SearchCaseSensitive As Long
    lstFound   As QStringList ' Handle 0 ParentHandle 0 ClassName 0 WindowText
    ' Found Window decoded Here
    ChildHandle         As Long
    ChildClassName      As String
    ChildWindowText     As String
    ParentHandle        As Long
Private:
    ClassName  As String
    WindowText As String
    iCount     As Long
' ---- Methods ------------------------
Public:
    Function GetClassName (Handle As Long) As String
        DefStr sClassName = Space$(512)
        DefInt iClassNameSize
        iClassNameSize = GCH_GetClassName (Handle, VarPtr(sClassName), 512)
        Result =  Left$(sClassName, iClassNameSize)
    End Function
    '
    Function GetWindowText (Handle As Long) As String    ' limited to 2048 char
        DefStr sWindowText = Space$(2048)
        DefInt iWindowTextSize
        iWindowTextSize = GCH_GetWindowText (Handle, VarPtr(sWindowText), 2048)
        Result =  Left$(sWindowText, iWindowTextSize)
    End Function
Private:
    Sub CreateList (hParent As Long)
        DefStr sOut, sCount , sClass, sText
        DefInt hLastChildFound = 0, hChild
        hChild = GCH_FindWindowEx(hParent, hLastChildFound, VarPtr(QWindowTools.ClassName), _
                                                                  VarPtr(QWindowTools.WindowText))
        While hChild <> 0
            Inc .iCount
            sCount = Space$(5 - Len(Str$(.iCount))) & Str$(.iCount) & "  " & .Separator
            ' piles the parents:  'child,<parent,<parent,<iParentHandle chr$(0)'
            .Wnd = Str$(hChild) & "," & .Wnd
            '
            ' GetClassName
            ' ------------
            sClass = .GetClassName (hChild)
            sOut = IIF(Len(sClass) > 0, sClass, "NoClass")
            '
            ' GetWindowText
            ' -------------
            sText = .GetWindowText(hChild)
            sOut = sOut & IIF(Len(sText) > 0, .Separator & sText, .Separator & "NoWindowText")
            ' -------------
            .lstResult.AddItems (sCount & .Wnd & sOut)
            .CreateList (hChild)  ' Recursive call
            hLastChildFound = hChild
            hChild = Str$(GCH_FindWindowEx(hParent, hLastChildFound, _
                                             VarPtr(QWindowTools.ClassName), VarPtr(QWindowTools.WindowText)))
        Wend
        ' unpiles the parents:    'child,parent,parent,lastparent chr$(0)'
        If Len(.Wnd) > Len(Str$(hParent)) + 1 Then .Wnd = Mid$(.Wnd, Instr(.Wnd, ",") + 1)
    End Sub
Public:
    '
    Sub GetChildsList (hParent As Long)
        .iCount = 0
        .Wnd = Str$(hParent) & Chr$(0)
        .lstResult.Clear
        .CreateList (hParent)
        .Result = .lstResult.Text
    End Sub
    '
    Sub DecodeFoundItem (sItem As String)
        .ChildHandle     = Val(Field$(sItem, Chr$(0), 1))
        .ParentHandle    = Val(Field$(sItem, Chr$(0), 2))
        .ChildClassName  =     Field$(sItem, Chr$(0), 3)
        .ChildWindowText =     Field$(sItem, Chr$(0), 4)
    End Sub
    '
    Sub SearchInClassNames (ToFind As String)
        DefInt i
        DefStr sHandle, sParentHandle
        DefStr sClassName, sWindowText, sLine, sToFind, sSearchIn, sFound
        .lstFound.Clear
        .GetChildsList (0)
        For i = 0 To .lstResult.ItemCount - 1
            sLine = .lstResult.Item(i)
            sClassName  = Field$(sLine, Chr$(0), 3)
            If .SearchCaseSensitive = 0 Then
                sToFind   = UCase$(ToFind)
                sSearchIn = UCase$(sClassName)
            Else
                sToFind   = ToFind
                sSearchIn = sClassName
            End If
            If Instr(sSearchIn, sToFind) <> 0 Then
                sHandle       = Field$(     Field$(sLine, Chr$(0), 2)     , ",", 1)
                sParentHandle = Field$(     Field$(sLine, Chr$(0), 2)     , ",", 2)
                sWindowText = Field$(sLine, Chr$(0), 4)
                '
                sFound = sHandle & .Separator & sParentHandle & .Separator & sClassName _
                                                                 & .Separator & sWindowText
                .lstFound.AddItems sFound
            End If
        Next i
        .DecodeFoundItem (sFound)
    End Sub
    '
    Sub SearchInWindowTexts (ToFind As String)
        DefInt i, n
        DefStr sHandle, sParentHandle
        DefStr sClassName, sWindowText, sLine, sToFind, sSearchIn, sFound
        .lstFound.Clear
        .GetChildsList (0)
        For i = 0 To .lstResult.ItemCount - 1
            sLine = .lstResult.Item(i)
            sWindowText = Field$(sLine, Chr$(0), 4)
            If .SearchCaseSensitive = 0 Then
                sToFind   = UCase$(ToFind)
                sSearchIn = UCase$(sWindowText)
            Else
                sToFind   = ToFind
                sSearchIn = sWindowText
            End If
            If Instr(sSearchIn, sToFind) <> 0 Then
                sHandle       = Field$(     Field$(sLine, Chr$(0), 2)     , ",", 1)
                sParentHandle = Field$(     Field$(sLine, Chr$(0), 2)     , ",", 2)
                sClassName = Field$(sLine, Chr$(0), 3)
                sFound = sHandle & .Separator & sParentHandle & .Separator & sClassName _
                                                                 & .Separator & sWindowText
                .lstFound.AddItems sFound
            End If
        Next i
       .DecodeFoundItem (sFound)
    End Sub
' ---- Constructor --------------------
    Constructor
        ClassName = ""
        WindowText = ""
        Wnd = "0" & Chr$(0)
        Result = ""
        lstResult.Clear
        iCount = 0
        Separator = Chr$(0)
        SearchCaseSensitive = 0 ' not case sensitive
    End Constructor
  End With
End Type
' -----------------------------------------------------------------------------
